    TITLE 'ROSMETRO E WATTMETRO - wattmeter03'
          ;CLUB AUTOCOSTRUTTORI ARI PADOVA Danilo 20 novembre 2004'
    list   p=PIC16C876,f=INHX8M
          __config H'3F31'
;--------------------------------------------------------------------*
;  01   ASSEGNAZIONI VARIE                                           *
;--------------------------------------------------------------------*
;PCL     EQU   02H              ; Contatore programma
STATUS  EQU   03H              ; Registro di stato
PORTA   EQU   05H              ; Porta A
PORTB   EQU   06H              ; Porta B
PORTC   EQU   07H              ; Porta C
ADCON0  EQU   1FH              ; Registro 0 conversione A/D
ADRESH  EQU   9EH              ; Risultato  conversioni A/D
ADCON1  EQU   9FH              ; Registro 1 conversione A/D
TRISA   EQU   85H              ; Configurazione porta A
TRISB   EQU   86H              ; Configurazione porta B
TRISC   EQU   87H              ; Configurazione porta C
EEDATA  EQU  10CH              ; Dato scritto o letto in EEPROM
EEADR   EQU  10DH              ; Indirizzo memoria EEPROM
EECON1  EQU  18CH              ; Registro EEPROM
EECON2  EQU  18DH              ; Registro EEPROM
                               ;
AARGB0  EQU   20H              ; Variabile calcolo
AARGB1  EQU   21H              ; Variabile calcolo
AARGB2  EQU   22H              ; Variabile calcolo
AARGB3  EQU   23H              ; Variabile calcolo
AARGB4  EQU   24H              ; Variabile calcolo
ACCaHI  equ   25H              ; Variabile calcolo
ACCaLO  equ   26H              ; Variabile calcolo
ACCbHI  equ   27H              ; Variabile calcolo
ACCbLO  equ   28H              ; Variabile calcolo
BARGB0  EQU   29H              ; Variabile calcolo
BARGB1  EQU   2AH              ; Variabile calcolo
BAR01   EQU   2BH              ; Variabile barra LCD
BAR02   EQU   2CH              ; Variabile barra LCD
BAR03   EQU   2DH              ; Variabile barra LCD
BAR04   EQU   2EH              ; Variabile barra LCD
BAR05   EQU   2FH              ; Variabile barra LCD
BAR06   EQU   30H              ; Variabile barra LCD
BAR07   EQU   31H              ; Variabile barra LCD
BAR08   EQU   32H              ; Variabile barra LCD
BAR09   EQU   33H              ; Variabile barra LCD
BAR10   EQU   34H              ; Variabile barra LCD
BAR11   EQU   35H              ; Variabile barra LCD
BAR12   EQU   36H              ; Variabile barra LCD
BAR13   EQU   37H              ; Variabile barra LCD
BAR14   EQU   38H              ; Variabile barra LCD
BAR15   EQU   39H              ; Variabile barra LCD
CENTI   EQU   6EH              ; Variabiloe centinaia WATT
CGU     EQU   3AH              ; Variabile lampeggio HIG ROS
COUNT1  EQU   3BH              ; Variabile calcolo
CSU     EQU   3CH              ; Variabile lampeggio HIG ROS
DECIM   EQU   3DH              ; Variabile decimi WATT
DECIN   EQU   3EH              ; Variabile decine WATT
FLOT1   EQU   3FH              ; Variabile Fw
FLOT2   EQU   40H              ; Variabile Fw
FLOT3   EQU   41H              ; Variabile Fw
FR01    EQU   42H              ; Ram uso ritardo
FR02    EQU   43H              ; Ram uso ritardo
FR03    EQU   44H              ; Ram uso ritardo
FR04    EQU   45H              ; Ram uso libero
K       EQU   46H              ; Variabile contatore
N       EQU   47H              ; Variabile contatore
PCEN    EQU   48H              ; Variabile centinaia WATT
PDEC    EQU   49H              ; Variabile decine di WATT
PROV1H  EQU   4AH              ; Variabile provvisoria
PROV1M  EQU   4BH              ; Variabile provvisoria
PROV1L  EQU   4CH              ; Variabile provvisoria
PROV2H  EQU   4DH              ; Variabile provvisoria
PROV2L  EQU   4EH              ; Variabile provvisoria
PUNI    EQU   4FH              ; Variabile unit  di WATT
PVIR    EQU   50H              ; Variabile decimi di WATT
REMB0   EQU   51H              ; Variabile calcolo
REMB1   EQU   52H              ; Variabile calcolo
RPUN    EQU   53H              ; Variabile punto     SWR
RUNI    EQU   54H              ; Variabile unit  di SWR
RVIR    EQU   55H              ; Variabile decimi di SWR
TCAMP   EQU   56H              ; Variabile tensione campione
TEMP    EQU   57H              ; Variabile provvisoria
TEMPB0  EQU   58H              ; Variabile calcolo
TEMPB1  EQU   59H              ; Variabile calcolo
TEMPB2  EQU   5AH              ; Variabile calcolo
UNITA   EQU   5BH              ; Variabile unita' WATT
VARH    EQU   5CH              ; Variabile alta      operazioni
VARL    EQU   5DH              ; Variabile bassa     operazioni
VARP2   EQU   5EH              ; Variabile pulsanti UP/DOWN
VARP3   EQU   5FH              ; Variabile UP
VARX    EQU   60H              ; Variabile di uso libero
VDIRE   EQU   61H              ; Variabile tensione diretta
Vfs     EQU   62H              ; Variabile tensione di picco
VHIG    EQU   63H              ; Variabile generale alta
VINVE   EQU   64H              ; Variabile tensione inversa
VLOW    EQU   65H              ; Variabile generale bassa
Vrs     EQU   66H              ; Variabile ros
V00001  EQU   67H              ; Variabile unit
V00010  EQU   68H              ; Variabile decine 
V00100  EQU   69H              ; Variabile centinaia
V01000  EQU   6AH              ; Variabile migliaia
V10000  EQU   6BH              ; Variabile diecimila
WCAMPH  EQU   6CH              ; Variabile alta  WATT di calibrazione
WCAMPL  EQU   6DH              ; Variabile bassa WATT di calibrazione
;       max   7FH
;--------------------------------------------------------------------*
;  02   DEFINIZIONI VARIE                                            *
;--------------------------------------------------------------------*
#define RS        PORTA,4      ; Register Select display pin A 06
#define CLK       PORTA,5      ; Clock display (enebol)  pin A 07
#define P1        PORTC,4      ; Pulsante #1 PROG.       pin C 15
#define P2        PORTC,5      ; Pulsante #2 DOWN        pin C 16
#define P3        PORTC,6      ; Pulsante #3 UP          pin C 17
;--------------------------------------------------------------------*
;  03   MAGO MERLINO                                                 *
;--------------------------------------------------------------------*
        ORG       0            ; Robe sue guai toccare
        goto      START        ; Reset vector vado a 04 >>>>>>>>>>>>>>>>>
        ORG       4            ; Interrupt vector
        retfie                 ; Roba de mago Merlino
;--------------------------------------------------------------------*
;  04   SETTAGGI REGISTRI E PORTE                                    *
;--------------------------------------------------------------------*
START   call      BANK1        ; Bank 1
        movlw     b'00000100'  ; risultato a sx xxxxxxxx - xx000000
                               ; Port A 0 ANALOGICO ref +5 0
                               ; Port A 1 ANALOGICO ref +5 0
                               ; Port A 2 DIGITALE
                               ; Port A 3 ANALOGICO ref +5 0
                               ; Port A 4 DIGITALE
                               ; Port A 5 DIGITALE
        movwf     ADCON1       ; Registro suddivisione port A
                               ;
        movlw     b'11001111'  ; Pin 02 A0 An inp = tensione diretta
                               ; Pin 03 A1 An inp = tensione inversa
                               ; Pin 04 A2 Di inp = libero
                               ; Pin 05 A3 An inp = libero
                               ; Pin 06 A4 Di out = RS     LCD
                               ; Pin 07 A5 Di out = ENEBOL LCD clock
        movwf     TRISA        ; Registro direzione port A
                               ;
        movlw     b'01111111'  ; Pin 21 B0 Di inp = libero
                               ; Pin 22 B1 Di inp = libero
                               ; Pin 23 B2 Di inp = libero
                               ; Pin 24 B3 Di inp = libero
                               ; Pin 25 B4 Di inp = libero
                               ; Pin 26 B5 Di inp = libero
                               ; Pin 27 B6 Di inp = libero
                               ; Pin 28 B7 Di inp = libero
        movwf     TRISB        ; Registro direzione port B
                               ;
        movlw     b'11110000'  ; Pin 11 C0 Di out = DB0/DB4 LCD
                               ; Pin 12 C1 Di out = DB1/DB5 LCD
                               ; Pin 13 C2 Di out = DB2/DB6 LCD
                               ; Pin 14 C3 Di out = DB3/DB7 LCD
                               ; Pin 15 C4 Di inp = PULS. 1 SET
                               ; Pin 16 C5 Di inp = PULS. 2 DOWN
                               ; Pin 17 C6 Di inp = PULS. 3 UP
                               ; Pin 18 C7 Di inp = libero
        movwf     TRISC        ; Pin B registro direzione
                               ;
        call      BANK0        ; Bank 0
                               ;
        clrf      PORTA        ; Porta A a 0
        clrf      PORTB        ; Porta B a 0
        clrf      PORTC        ; Porta C a 0
;--------------------------------------------------------------------*
;  05   RESET INIZIALE LCD                                           *
;--------------------------------------------------------------------*
        call      RI060M       ;
        movlw     b'00000011'  ; Reset soft  1
        movwf     PORTC        ; 
        call      CLOCK2       ; Enebol
        call      RI005M       ;
        movlw     b'00000011'  ; Reset soft  2
        movwf     PORTC        ;
        call      CLOCK2       ; Enebol
        call      RI005M       ;
        movlw     b'00000011'  ; Reset soft  3
        movwf     PORTC        ;
        call      CLOCK2       ; Enebol
        call      RI005M       ;
        movlw     b'00000010'  ; Reset soft
        movwf     PORTC        ;
        call      CLOCK2       ; Enebol
        call      RI005M       ;
        movlw     b'00101000'  ; 4 bit dati 2 linee display
        call      WRITE        ;
        movlw     b'00001000'  ; LCD off per reset
        call      WRITE        ;
        movlw     b'00001100'  ; LCD on - curs off - sottoli off
        call      WRITE        ;
        movlw     b'00000001'  ; Cursore a 1 e clear
        call      WRITE        ;
        call      RI500M       ;
;--------------------------------------------------------------------*
;  06   SCRITTURA CARATTERI BARRA Vf SU CG-RAM LCD                   *
;--------------------------------------------------------------------*
        movlw     b'01000000'  ; indirizzo inizio CG RAM
        call      WRITE        ;
        bsf       RS           ;
        call      RI005M       ;
        movlw     .1           ; Griglia modello righe 1, 3, 7, 15,
        movwf     VARP3        ; 31, 63, 127, 255
LA00    movf      VARP3,0      ;
        movwf     VARX         ;
        movlw     .9           ;
        movwf     VARP2        ; Contatore cicli
LA01    decfsz    VARP2,1      ;
        goto      LA02         ;
        goto      LA03         ;
LA02    movlw     .255         ; Riga piena (1)
        rlf       VARX,1       ; Verifica valore bit
        btfss     STATUS,0     ;
        clrw                   ; Riga vuota (0)
        call      WRITE        ;
        goto      LA01         ;
LA03    movf      VARP3,0      ; Incremento passi griglia
        xorlw     .255         ; Verifica termine scrittura
        btfsc     STATUS,2       ;
        goto      PRESE        ; Vado a 07 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        movf      VARP3,0      ; Montaggio griglia
        addwf     VARP3,1      ;
        incf      VARP3,1      ;
        goto      LA00         ;
;--------------------------------------------------------------------*
;  07   SCRITTA PRESENTAZIONE SU LCD                                 *
;--------------------------------------------------------------------*
PRESE   bcf       RS           ; RS basso per comandi
        call      RI005M       ; Indirizzo 0 di DD RAM
        movlw     b'10000000'  ;
        call      WRITE        ;
        movlw     .1           ; Cursore a capo e cancellazione LCD
        call      WRITE        ;
        bsf       RS           ; Reg. Select a 1 per dati
        call      RI005M       ;
        movlw     ' '          ; R1  C01   =  spazio
        call      WRITE        ;
        movlw     'S'          ; R1  C02   =  S
        call      WRITE        ;
        movlw     'W'          ; R1  C03   =  W
        call      WRITE        ;
        movlw     'R'          ; R1  C04   =  R
        call      WRITE        ; 
        movlw     '/'          ; R1  C05   =  /
        call      WRITE        ;
        movlw     'W'          ; R1  C06   =  W
        call      WRITE        ;
        movlw     'A'          ; R1  C07   =  A
        call      WRITE        ;
        movlw     'T'          ; R1  C08   =  T
        call      WRITE        ;
        movlw     'T'          ; R1  C09   =  T
        call      WRITE        ;
        movlw     ' '          ; R1  C10   =  spazio
        call      WRITE        ;
        movlw     'M'          ; R1  C11   =  M
        call      WRITE        ;
        movlw     'E'          ; R1  C12   =  E
        call      WRITE        ;
        movlw     'T'          ; R1  C13   =  T
        call      WRITE        ;
        movlw     'E'          ; R1  C14   =  E
        call      WRITE        ;
        movlw     'R'          ; R1  C15   =  R
        call      WRITE        ;
        movlw     ' '          ; R1  C16   =  spazio
        call      WRITE        ;
        bcf       RS           ; Reg. Select a 0 per istruzioni
        call      RI005M       ; Ritardo
        movlw     .192         ; Indirizzo inizio seconda riga
        call      WRITE        ;
        bsf       RS           ; Reg. Select a 1 per dati
        call      RI005M       ; Ritardo
        movlw     ' '          ; R2  C01   =
        call      WRITE        ;
        movlw     ' '          ; R2  C02   =
        call      WRITE        ;
        movlw     ' '          ; R2  C03   =
        call      WRITE        ;
        movlw     ' '          ; R2  C04   =
        call      WRITE        ;
        movlw     ' '          ; R2  C05   =
        call      WRITE        ;
        movlw     ' '          ; R2  C06   =
        call      WRITE        ;
        movlw     ' '          ; R2  C07   =
        call      WRITE        ;
        movlw     ' '          ; R2  C08   =
        call      WRITE        ;
        movlw     ' '          ; R2  C09   =
        call      WRITE        ;
        movlw     ' '          ; R2  C10   =
        call      WRITE        ;
        movlw     ' '          ; R2  C11   =
        call      WRITE        ;
        movlw     ' '          ; R2  C12   =
        call      WRITE        ;
        movlw     ' '          ; R2  C13   =
        call      WRITE        ;
        movlw     ' '          ; R2  C14   =
        call      WRITE        ;
        movlw     ' '          ; R2  C15   =
        call      WRITE        ;
        movlw     ' '          ; R2  C16   =
        call      WRITE        ;
        call      RI750M       ; I  Tempo visione scritta iniziale
        call      RI750M       ; II Tempo visione scritta iniziale
;--------------------------------------------------------------------*
;  08   LETTURA DATI CALIBRAZIONE DA EEPROM                          *
;--------------------------------------------------------------------*
LETTU   call      BANK2        ; BANK 2
        movlw     .0           ; Indirizzo EEPROM 0
        movwf     EEADR        ; Registro indirizzi EEPROM
        call      BANK3        ; BANK 3
        bcf       EECON1,7     ; EEPGD puntatore memoria dati
        bsf       EECON1,0     ; Inizio lettura
        call      BANK2        ; BANK 2
        movf      EEDATA,0     ; Contiene il dato memorizzato 
        call      BANK0        ; BANK 0
        xorlw     .85          ; Spia memo calibrazione
        btfsc     STATUS,2     ;
        goto      LETTU2       ; Calibrazione gi eseguita
        movlw     .95          ; Calibrazione mai eseguita
        movwf     TCAMP        ; Memorizzo dati default
        movlw     .0           ; Tensione 1,90 volt
        movwf     WCAMPH       ; Watt    20 
        movlw     .200         ;
        movwf     WCAMPL       ;
        call      MEMO         ;
LETTU2  call      BANK2        ; BANK 2
        movlw     .1           ; Indirizzo EEPROM 1
        movwf     EEADR        ; Registro indirizzi EEPROM
        call      BANK3        ; BANK 3
        bcf       EECON1,7     ; EEPGD puntatore memoria dati
        bsf       EECON1,0     ; Inizio lettura
        call      BANK2        ; BANK 2
        movf      EEDATA,0     ; Contiene il dato memorizzato 
        call      BANK0        ; BANK 0
        movwf     TCAMP        ; Tensione campionamento
                               ;
        call      BANK2        ; BANK 2
        movlw     .2           ; Indirizzo EEPROM 2
        movwf     EEADR        ; Registro indirizzi EEPROM
        call      BANK3        ; BANK 3
        bcf       EECON1,7     ; EEPGD puntatore memoria dati
        bsf       EECON1,0     ; Inizio lettura
        call      BANK2        ; BANK 2
        movf      EEDATA,0     ; Contiene il dato memorizzato 
        call      BANK0        ; BANK 0 
        movwf     WCAMPH       ; Watt campionamento parte alta
                               ;
        call      BANK2        ; BANK 2
        movlw     .3           ; Indirizzo EPROM 3
        movwf     EEADR        ; Registro indirizzi EEPROM
        call      BANK3        ; BANK 3
        bcf       EECON1,7     ; EEPGD puntatore memoria dati
        bsf       EECON1,0     ; Inizio lettura
        call      BANK2        ; BANK 2
        movf      EEDATA,0     ; Contiene i dato memorizzato 
        call      BANK0        ; BANK 0
        movwf     WCAMPL       ; Watt campionamento parte bassa
;--------------------------------------------------------------------*
;  09   VERIFICA TASTO CALIBRAZIONE WATMETRO                         *
;--------------------------------------------------------------------*
PULS01  btfsc     P1           ; Verifica pulsante calibrazione WATT
        goto      NOIL1        ; Se non premuto vado a 10 >>>>>>>>>>>>>>>
PULSP11 btfss     P1           ; Aspetto il rilascio
        goto      PULSP11      ;
        goto      SETW         ; Se  premuto  vado   a 50 >>>>>>>>>>>>>>>
;--------------------------------------------------------------------*
;  10   AZZERAMENTO VARIABILI E DISPLAY                              *
;--------------------------------------------------------------------*
NOIL1   movlw     .32          ; Valore spazio ascii in
        movwf     BAR01        ; Barra potenza da 1 a 15
        movwf     BAR02        ;
        movwf     BAR03        ;
        movwf     BAR04        ;
        movwf     BAR05        ;
        movwf     BAR06        ;
        movwf     BAR07        ;
        movwf     BAR08        ;
        movwf     BAR09        ;
        movwf     BAR10        ;
        movwf     BAR11        ;
        movwf     BAR12        ;
        movwf     BAR13        ;
        movwf     BAR14        ;
        movwf     BAR15        ;
        movwf     FLOT1        ;
        movwf     FLOT2        ;
        movwf     PDEC         ;
        movlw     .45          ; Valore - ascii in
        movwf     RUNI         ; unita'    SWR
        movwf     RVIR         ; decimali  SWR
        movwf     PUNI         ; unita'    Pw
        movwf     PVIR         ; decimali  Pw
        movlw     .5           ; Var lamp HIG ROS
        movwf     CSU          ;
        movlw     '.'          ;
        movwf     RPUN         ;
        movlw     'w'          ;
        movwf     PCEN         ;
        movlw     'P'          ;
        movwf     FLOT3        ;
        clrf      N            ;
        clrf      K            ;
        clrf      Vfs          ;
		clrf	  Vrs		   ;	
        call      VISOR        ;
;--------------------------------------------------------------------*
;  11   CICLO RITARDO STABILIZZATORE MISURA                          *
;--------------------------------------------------------------------*
                               ;
NOIL2   call      RI060M       ; Ritardo 100 mS
                               ;
;--------------------------------------------------------------------*
;  12   LETTURA TENSIONE DIRETTA, RIFLESSA E CORREZIONE VALORI       *
;--------------------------------------------------------------------*
        movlw     b'01000001'  ; Bit 6 7   = 01  Fosc/8
                               ; Bit 5 4 3 = 000 Canale 0
                               ; Bit 2     = 0   Stop conversione
                               ; Bit 1     = 0   non usato
                               ; Bit 0     = 1   A/D in uso
        movwf     ADCON0       ; Registro A/D ADCON0
        call      RI005M       ; Tempo assestamento ingresso
        bsf       ADCON0,2     ; Bit 2     = 1   Start conversione
ATTES0  btfsc     ADCON0,2     ; Attesa termine conversione
        goto      ATTES0       ;
        movf      ADRESH,0     ; Risultato conversione A/D
        movwf     VDIRE        ; Tensione diretta canale 0
                               ;
        movlw     b'01001001'  ; Bit 6 7   = 0 1 Fosc/8
                               ; Bit 5 4 3 = 001 Canale 1
                               ; Bit 2     = 0   Stop conversione
                               ; Bit 1     = 0 non usato
                               ; Bit 0     = 1 A/D in uso
        movwf     ADCON0       ; Registro A/D ADCON0
        call      RI005M       ; Tempo assestamento ingresso
        bsf       ADCON0,2     ; Bit 2     = 1   Start conversione
ATTES1  btfsc     ADCON0,2     ; Attesa termine conversione
        goto      ATTES1       ;
        movf      ADRESH,0     ; Risultato conversione A/D
        movwf     VINVE        ; Tensione inversa canale 1
                               ;
        movf      VDIRE,0      ; Valore Vdir da corregere
        movwf     PROV1L       ;
        call      COR00        ; Sub correzione
        movf      PROV1L,0     ; 
        movwf     VDIRE        ; Valore Vdir corretto
                               ;
        movf      VINVE,0      ; Valore Vinv da corregere
        movwf     PROV1L       ;
        call      COR00        ; Sub correzione
        movf      PROV1L,0     ;
        movwf     VINVE        ; Valore Vinv corretto
;--------------------------------------------------------------------*
;  13   VERIFICA SOGLIA MINIMA TRASMISSIONE                          *
;--------------------------------------------------------------------*
;  13a                         ;
        movf      VINVE,0      ; Somma tra Vdir e Vinv
        addwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      VDB          ; Al di sopra del 255 vado a 14 >>>>>>>>>>
        sublw     .30          ; Al di sotto del 255 verifico
        btfss     STATUS,0     ; soglia validit Vd+Vi = 30 0.6 volt
        goto      VDB          ; Vd + Vi sufficente  vado a 14 >>>>>>>>>>
;  13b                         ;
        movf      N,0          ; Vd + Vi insufficente
        sublw     .20          ; Cicli con Vd + Vi insufficenti
        btfss     STATUS,0     ; Se  raggiunto numero cicli
        goto      PULS01       ;                     vado a 09 >>>>>>>>>>
;  13c                         ;
        incf      N,1          ; Non raggiunto numero cicli
        goto      NOIL2        ;                     vado a 11 >>>>>>>>>>
;--------------------------------------------------------------------*
;  14   AGGIORNAMENTO CONTATORI CICLO MISURA                         *
;--------------------------------------------------------------------*
VDB     clrf      N            ;
        incf      K,1          ;
;--------------------------------------------------------------------*
;  15   CALCOLO E DISPLAY VALORE BARRA Vf                            *
;--------------------------------------------------------------------*
BA00    movlw     .0           ; Carico valori attivi barra Vf
        movwf     BAR01        ;
        movlw     .1           ;
        movwf     BAR02        ;
        movwf     BAR03        ;
        movlw     .2           ;
        movwf     BAR04        ;
        movwf     BAR05        ;
        movlw     .3           ;
        movwf     BAR06        ;
        movwf     BAR07        ;
        movlw     .4           ;
        movwf     BAR08        ;
        movwf     BAR09        ;
        movlw     .5           ;
        movwf     BAR10        ;
        movwf     BAR11        ;
        movlw     .6           ;
        movwf     BAR12        ;
        movwf     BAR13        ;
        movlw     .7           ;
        movwf     BAR14        ;
        movwf     BAR15        ;
BA01    movlw     .17          ; Confronto tensione con barra  1
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA02         ; Pi alta  lascio attivo
        movlw     .32          ; Pi bassa tolgo  attivo
        movwf     BAR01        ;
BA02    movlw     .34          ; Confronto tensione con barra  2
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA03         ;
        movlw     .32          ;
        movwf     BAR02        ;
BA03    movlw     .51          ; Confronto tensione con barra  3
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA04         ;
        movlw     .32          ;
        movwf     BAR03        ;
BA04    movlw     .68          ; Confronto tensione con barra  4
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA05         ;
        movlw     .32          ;
        movwf     BAR04        ;
BA05    movlw     .85          ; Confronto tensione con barra  5
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA06         ;
        movlw     .32          ;
        movwf     BAR05        ;
BA06    movlw     .102         ; Confronto tensione con barra  6
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA07         ;
        movlw     .32          ;
        movwf     BAR06        ;
BA07    movlw     .119         ; Confronto tensione con barra  7
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA08         ;
        movlw     .32          ;
        movwf     BAR07        ;
BA08    movlw     .136         ; Confronto tensione con barra  8
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA09         ;
        movlw     .32          ;
        movwf     BAR08        ;
BA09    movlw     .153         ; Confronto tensione con barra  9
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA10         ;
        movlw     .32          ;
        movwf     BAR09        ;
BA10    movlw     .170         ; Confronto tensione con barra 10
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA11         ;
        movlw     .32          ;
        movwf     BAR10        ;
BA11    movlw     .187         ; Confronto tensione con barra 11
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA12         ;
        movlw     .32          ;
        movwf     BAR11        ;
BA12    movlw     .204         ; Confronto tensione con barra 12
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA13         ;
        movlw     .32          ;
        movwf     BAR12        ;
BA13    movlw     .221         ; Confronto tensione con barra 13
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA14         ;
        movlw     .32          ;
        movwf     BAR13        ;
BA14    movlw     .238         ; Confronto tensione con barra 14
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA15         ;
        movlw     .32          ;
        movwf     BAR14        ;
BA15    movlw     .254         ; Confronto tensione con barra 15
        subwf     VDIRE,0      ;
        btfsc     STATUS,0     ;
        goto      BA16         ;
        movlw     .32          ;
        movwf     BAR15        ;
BA16    call      INBAR        ;
;-------------------------------------------------------------------*
;  18   VERIFICA CONTATORE MISURA PICCO POTENZA                     *
;-------------------------------------------------------------------*
;  18a                         ;
        movf      K,0          ;
        sublw     .15          ; Numero letture per ciclo
        btfsc     STATUS,0     ;
        goto      MEDIA        ; No raggiunto vado a 19 >>>>>>>>>>>>>>>>>
;  18b                         ;
        clrf      K            ; Si raggiunto numero cicli
        clrf      Vfs          ; Azzero potenza di picco
        clrf      Vrs          ; Azzero ros     di picco
;-------------------------------------------------------------------*
;  19   VERIFICA LIVELLO PICCO POTENZA                              *
;-------------------------------------------------------------------*
;  19a                         ;
MEDIA	
	movf      VINVE,0      ; Confronto misura letta Vr 
        subwf     Vrs,0        ; con misura memorizzata Vrs
        btfsc     STATUS,0     ; 
        goto      no_save      ; Lettura minore o uguale prosegui
        movf      VINVE,0      ; Lettura pi alta aggiorno
        movwf     Vrs          ; variabile Vrs inversa di picco
no_save
	movf      VDIRE,0      ; Confronto misura letta Vf 
        subwf     Vfs,0        ; con misura memorizzata Vfs
        btfsc     STATUS,0     ; 
        goto      dyspf        ; Lettura minore o uguale >>> display valore di picco
;  19b                         ;
        movf      VDIRE,0      ; Lettura pi alta aggiorno
        movwf     Vfs          ; variabile Vfs diretta di picco
        clrf      K            ; azzero il contatore
        goto      NOIL2        ; e vado a 11 >>>>>>>>>>>>>>
;-------------------------------------------------------------------*
;  20   CALCOLO E DISPLAY VALORE POTENZA (Pf) PICCO PICCO           *
;-------------------------------------------------------------------*
dyspf
        movf      Vfs,0        ; MOVE VFs in VDIRE per routine CALWAT
        movwf     VDIRE        ; 
        call      CALWAT       ; Sub calcolo WATT
        movlw     'P'          ; Pw scorrevole per centinaia
        movwf     FLOT1        ;
        movlw     'w'          ;
        movwf     FLOT2        ;
        movlw     .32          ;
        movwf     FLOT3        ;
        movf      PCEN,0       ; Soppressione  zero  non
        xorlw     .48          ; significativo centinaia
        btfss     STATUS,2     ;
        goto      ZERO         ;
        movlw     .32          ;
        movwf     PCEN         ;
        movwf     FLOT1        ; Pw scorrevole per decine
        movlw     'P'          ;
        movwf     FLOT2        ;
        movlw     'w'          ;
        movwf     FLOT3        ;
        movf      PDEC,0       ; Soppressione zero non
        xorlw     .48          ; significativo  decine
        btfss     STATUS,2     ;
        goto      ZERO         ;
        movlw     .32          ;
        movwf     PDEC         ;
        movwf     FLOT1        ; Pw scorrevole per unita'
        movwf     FLOT2        ;
        movlw     'P'          ;
        movwf     FLOT3        ;
        movlw     'w'          ;
        movwf     PCEN         ;
;--------------------------------------------------------------------*
;  16  CALCOLO SWR                                                   *
;--------------------------------------------------------------------*
;       CALCOLO SWR: ((((Vdir+Vrif)*100)/(Vdir-Vrif))+5)/10
ZERO                           ;
        movlw     .0           ;
        movwf     ACCaHI       ; Parte alta  Vdiretta  a 0
        movf      Vfs,0        ; Tensione diretta di picco misurata
        movwf     ACCaLO       ; Parte bassa Vdiretta
        movlw     .0           ;
        movwf     ACCbHI       ; Parte alta  Vriflessa a 0
        movf      Vrs,0        ; Tensione inversa di picco misurata
        movwf     ACCbLO       ; Parte bassa Vriflessa
                               ;
        call      D_add        ; ADDIZIONE Vdir + Vrif
                               ;
        movlw     .0           ;
        movwf     AARGB0       ; Parte alta  moltiplicando a 0
        movf      ACCbHI,0     ; Parte alta  risultato addizione in
        movwf     AARGB1       ; parte media moltiplicando
        movf      ACCbLO,0     ; Parte bassa risultato addizione
        movwf     AARGB2       ; Parte bassa moltiplicando
        movlw     .0           ;
        movwf     BARGB0       ; Parte alta  moltiplicando a 0
        movlw     .100         ;
        movwf     BARGB1       ; Moltiplicatore
                               ;
        call      MOLTI        ; MOLTIPLICAZIONE (Vdir + Vrif) * 10
                               ;
        movf      AARGB3,0     ; Parte media risultato moltiplicazione
        movwf     PROV1M       ;
        movf      AARGB4,0     ; Parte bassa risultato moltiplicazione
        movwf     PROV1L       ;
        movlw     .0           ;
        movwf     ACCaHI       ; Parte alta  Vriflessa a 0
        movf      Vrs,0        ; Tensione inversa di picco misurata
        movwf     ACCaLO       ; Parte bassa Vdiretta
        movlw     .0           ;
        movwf     ACCbHI       ; Parte alta  Vdiretta  a 0 
        movf      Vfs,0        ; Tensione diretta di picco misurata
        movwf     ACCbLO       ; Parte bassa Vdiretta  
                               ;
        call      D_sub        ; SOTTRAZIONE (Vdir -Vrif)
                               ;
        movf      ACCbHI,0     ; Parte alta  ris. sottrazione in
        movwf     BARGB0       ; parte alta divisore
        movf      ACCbLO,0     ; Parte bassa ris. sottrazione in
        movwf     BARGB1       ; parte bassa divisore
        movlw     .0           ;
        movwf     AARGB0       ; Parte alta dividendo a 0
        movwf     AARGB1       ; Parte alta  dividendo
        movf      PROV1M,0     ; Parte media di (Vdir + Vrif) * 10
        movwf     AARGB2       ; Parte media dividendo
        movf      PROV1L,0     ; Parte alta  di (Vdir - Vrif)
        movwf     AARGB3       ; Parte alta  divisore
                               ;
        call      DIVIS        ; DIVISIONE 
                               ;
        movf      AARGB2,0     ; Parte alta risultato divisione
        movwf     ACCaHI       ; Parte alta  addendo 
        movf      AARGB3,0     ; Parte bassa risultato divisione
        movwf     ACCaLO       ; Parte bassa addendo
        movlw     .0           ;
        movwf     ACCbHI       ; Parte alta  addendo
        movlw     .5           ; Arrotondamento decimale
        movwf     ACCbLO       ; Parte bassa addendo 
                               ;
        call      D_add        ; ADDIZIONE 
                               ;
        movlw     .0           ;
        movwf     AARGB0       ; Parte alta  dividendo a 0
        movwf     AARGB1       ; parte media dividendo a 0
        movwf     BARGB0       ;
        movf      ACCbHI,0     ; Parte alta  risultato addizione in
        movwf     AARGB2       ; Parte bassa dividendo
        movf      ACCbLO,0     ; Parte bassa risultato addizione
        movwf     AARGB3       ; Parte bassa risultato divisione
        movlw     .10          ;
        movwf     BARGB1       ;
                               ;
        call      DIVIS        ;
                               ;
        movf      AARGB2,0     ; Parte alta risultato divisione
        movwf     VHIG         ;
        movf      AARGB3,0     ; Parte alta  dividendo
        movwf     VLOW         ;
        call      COLLE        ; Scomposizione numero
;--------------------------------------------------------------------*
;  17   VERIFICA HIG ROS                                             *
;--------------------------------------------------------------------*
        movf      V00100,0     ;
        xorlw     .0           ; Verifica livello ROS
        btfss     STATUS,2     ;
        goto      CSUGU        ; per lampeggio scritta HIG
        movf      V00010,0     ;
        sublw     .4           ; Soglia di ROS 
        btfsc     STATUS,0     ;
        goto      LROS         ; Sotto la soglia vado a LOW ROS
CSUGU   decfsz    CSU,1        ; Sopra la soglia vado a HIG 
        goto      ACCSPE       ;
        movlw    .7            ; Velocit lampeggio
        movwf     CSU          ;
        movlw    .1            ;
        xorwf     CGU,1        ; Inversione acceso/spento
ACCSPE  btfss     CGU,0        ;
        goto      HIROSS       ; Vado a HIG ROS SPENTO
HROSA   movlw     'H'          ; Sono a HIG ROS ACCESO
        movwf     RUNI         ;
        movlw     'I'          ;
        movwf     RPUN         ;
        movlw     'G'          ;
        movwf     RVIR         ;
        goto      VROS         ; Vado a visione scritta ros
HIROSS  movlw     ' '          ; Sono a HIG ROS SPENTO
        movwf     RUNI         ;
        movlw     ' '          ;
        movwf     RPUN         ;
        movlw     ' '          ;
        movwf     RVIR         ;
        goto      VROS         ;
LROS    movf      V00010,0     ; Risultato scomposizione
        addlw     .48          ; Prefisso ASCII
        movwf     RUNI         ; Unit    SWR
        movf      V00001,0     ; Risultato scomposizione
        addlw     .48          ; Prefisso ASCII
        movwf     RVIR         ; Decimale SWR
        movlw     '.'          ;
        movwf     RPUN         ;
VROS    call      VISOR        ;
        goto      NOIL2        ; Fine ciclo vado a 11 >>>>>>>>>>>>>>>>>>>
;--------------------------------------------------------------------*
;  50  SCOMPOSIZIONE CIFRA WATT DI CALIBRAZIONE PER LCD              *
;--------------------------------------------------------------------*
SETW    clrf      BAR01        ; Ingresso da 09 <<<<<<<<<<<<<<<<<<<<<<<<<
        clrf      BAR02        ; Variabili uso vario
        clrf      BAR03        ;
        clrf      BAR04        ;
        clrf      BAR05        ;
        movlw     .32          ;
        movwf     BAR06        ;
        movwf     BAR07        ;
        movlw     b'01000001'  ; Freq/8, Can 0
        movwf     ADCON0       ; Registro A/D ADCON0
SETW00  movf      WCAMPH,0     ;
        movwf     VHIG         ; Valore alto su variabile generale
        movf      WCAMPL,0     ;
        movwf     VLOW         ; Valore basso su variabile generale
        call      COLLE        ; Vado alla SUB di composizione
        movf      V00001,0     ; Valore decimi scomposto
        addlw     .48          ; Aggiungo prefisso ASCHII
        movwf     DECIM        ;
        movf      V00010,0     ; Valore unit scomposto
        addlw     .48          ; Aggiungo prefisso ASCHII
        movwf     UNITA        ;
        movf      V00100,0     ; Valore decine scomposto 
        addlw     .48          ; Aggiungo prefisso ASCHII
        movwf     DECIN        ; 
        movf      V01000,0     ; Valore decine scomposto 
        addlw     .48          ; Aggiungo prefisso ASCHII
        movwf     CENTI        ; 
        movf      CENTI,0      ; Sopprimo lo zero non significativo
        xorlw     .48          ;
        btfss     STATUS,2     ;
        goto      SETW03       ; Fine scomp. valore WATT vado a 51 >>>>>>
        movlw     ' '          ;
        movwf     CENTI        ;
        movf      DECIN,0      ; Sopprimo lo zero non significativo
        xorlw     .48          ;
        btfss     STATUS,2     ;
        goto      SETW03       ; Fine scomp. valore WATT vado a 51 >>>>>>
        movlw     ' '          ;
        movwf     DECIN        ;
;--------------------------------------------------------------------*
;--------------------------------------------------------------------*
;  51   SCRITTA CALIBRAZIONE SET WATT                                *
;--------------------------------------------------------------------*
;--------------------------------------------------------------------*
SETW03  bcf       RS           ; Reg. Select a 0 per istruzioni
        call      RI005M       ;
        movlw     .2           ; Cursore in R1 C01 e CLR
        call      WRITE        ;
        bsf       RS           ; Reg. Select a 1 per dati
        call      RI005M       ;
        movlw     'C'          ; R 1  C 01   =  C
        call      WRITE        ;
        movlw     'A'          ; R 1  C 02   =  A
        call      WRITE        ;
        movlw     'L'          ; R 1  C 03   =  L
        call      WRITE        ;
        movlw     'I'          ; R 1  C 04   =  I
        call      WRITE        ;
        movlw     'B'          ; R 1  C 05   =  B
        call      WRITE        ;
        movlw     'R'          ; R 1  C 06   =  R
        call      WRITE        ;
        movlw     'A'          ; R 1  C 07   =  A
        call      WRITE        ;
        movlw     'Z'          ; R 1  C 08   =  Z
        call      WRITE        ;
        movlw     'I'          ; R 1  C 09   =  I
        call      WRITE        ;
        movlw     'O'          ; R 1  C 10   =  O
        call      WRITE        ;
        movlw     'N'          ; R 1  C 11   =  N
        call      WRITE        ;
        movlw     'E'          ; R 1  C 12   =  E
        call      WRITE        ;
        movlw     ' '          ; R 1  C 13   =  spazio
        call      WRITE        ;
        movlw     ' '          ; R 1  C 14   =  spazio
        call      WRITE        ;
        movf      BAR06,0      ; R 1  C 15   =  O/spazio
        call      WRITE        ;
        movf      BAR07,0      ; R 1  C 16   =  K/spazio
        call      WRITE        ;
        bcf       RS           ; Reg. Select a 0 per istruzioni
        call      RI005M       ;
        movlw     .192         ; Cursore in R2 C01
        call      WRITE        ;
        bsf       RS           ; Reg. Select a 1 per dati
        call      RI005M       ;
        movlw     'i'          ; R 2  C 01   =  i
        call      WRITE        ;
        movlw     'n'          ; R 2  C 02   =  n
        call      WRITE        ;
        movlw     'p'          ; R 2  C 03   =  p
        call      WRITE        ;
        movlw     'u'          ; R 2  C 04   =  u
        call      WRITE        ;
        movlw     't'          ; R 2  C 05   =  t
        call      WRITE        ;
        movlw     ' '          ; R 2  C 06   =  spazio
        call      WRITE        ;
        movlw     'w'          ; R 2  C 07   =  w
        call      WRITE        ;
        movlw     'a'          ; R 2  C 08   =  a
        call      WRITE        ;
        movlw     't'          ; R 2  C 09   =  t
        call      WRITE        ;
        movlw     't'          ; R 2  C 10   =  t
        call      WRITE        ;
        movlw     ' '          ; R 2  C 11   =  spazio
        call      WRITE        ;
        btfsc     BAR01,0      ;
        goto      SPENTO       ;
ACCESO  bsf       BAR01,0      ;
        movf      CENTI,0      ; R2   C 12   =  I   cifra  x00,0
        call      WRITE
        movf      DECIN,0      ; R 2  C 13   =  II  cifra  0x0,0
        call      WRITE        ;
        movf      UNITA,0      ; R 2  C 14   =  III cifra  00x,0
        call      WRITE        ;
        movlw     '.'          ; R 2  C 15   =  .
        call      WRITE        ;
        movf      DECIM,0      ; R 2  C 16   =  IV  cifra  000,x
        call      WRITE        ;
        goto      PULSA91      ;
SPENTO  bcf       BAR01,0      ;
        movlw     ' '          ; R 2  C 12   =  spazio
        call      WRITE        ;
        movlw     ' '          ; R 2  C 13   =  spazio
        call      WRITE        ;
        movlw     ' '          ; R 2  C 14   =  spazio
        call      WRITE        ;
        movlw     ' '          ; R 2  C 15   =  spazio
        call      WRITE        ;
        movlw     ' '          ; R 2  C 16   =  spazio
        call      WRITE        ;
        movlw     .200         ;
        movwf     BAR02        ;
;--------------------------------------------------------------------*
;   52  GESTIONE PULSANTI UP/DOWN/SET PER CALIBRAZIONE               *
;--------------------------------------------------------------------*
PULSA90 decfsz    BAR02,1      ; Ciclo attesa e lampeggio tasto on
        goto      PULSA20      ; Lettura tasti per pressione
        goto      SETW00       ; Scrittura su LCD
PULSA91 decfsz    BAR02,1      ; Ciclo attesa e lampeggio tasto off
        goto      PULSA92      ; Lettura tasti per rilascio
        goto      SETW00       ; Scrittura su LCD
PULSA92 call      RITAST       ;
        btfsc     P2           ;
        clrf      VARP2        ;
        call      RITAST       ;
        btfsc     P3           ;
        clrf      VARP3        ;
        call      RITAST       ;
        goto      PULSA91      ;
PULSA20 call      RITAST       ; Pulsante P2 DOWN decrementa
        btfsc     P2           ; Test pressione pulsante P2 DOWN
        goto      PULSA30      ; No premuto vado al pulsante 3
        incf      VARP2,1      ;
        movlw     .9           ; Si premuto precarico variabile con 9
        movwf     BAR03        ;
        movf      VARP2,0      ; Verifico soglia cifre lente/veloci
        sublw     .8           ; Soglia cambio cifre lente/veloci
        btfsc     STATUS,0     ;
        clrf      BAR03        ; No raggiunta azzero variabile
        incf      BAR03,1      ; Valore 1 per lento, 10 per veloce
        movlw     .0           ;
        xorwf     WCAMPH,0     ;
        btfsc     STATUS,2     ;
        goto      PULSA21      ; Se H si 0 vado a PULSA21
        movf      BAR03,0      ; Se H no 0 decremento
        subwf     WCAMPL,1     ; Decremento Watt campione di 0.1 o 1.0
        btfsc     STATUS,0     ;
        goto      PULSA91      ; No arrivato a 0
        decf      WCAMPH,1     ; Si arrivato a 0
        goto      PULSA91      ;
PULSA21 movf      BAR03,0      ;
        subwf     WCAMPL,1     ; Decremento Watt campione di 0.1 o 1.0
        movf      WCAMPL,0     ; Verifico se raggiunto il minimo
        sublw     .49          ; Limite inferiore cifra 
        btfss     STATUS,0     ;
        goto      PULSA91      ; No raggiunta
        movlw     .3           ;
        movwf     WCAMPH       ; Si raggiunta
        movlw     .232         ; carico cifra superiore 100.0
        movwf     WCAMPL       ;
        goto      PULSA91      ;
PULSA30 call      RITAST       ; Tasto P3 UP incrementa
        btfsc     P3           ; Test pressione pulsante P3 UP
        goto      PULSA10      ; No: vado a pulsante P1 SET
        incf      VARP3,1      ;
        movlw     .9           ; Si premuto precarico variabile con 9
        movwf     BAR03        ;
        movf      VARP3,0      ; Verifico soglia cifre lente/veloci
        sublw     .8           ; Soglia cambio cifre lente/veloci
        btfsc     STATUS,0     ;
        clrf      BAR03        ; No raggiunta azzero variabile
        incf      BAR03,1      ; Valore 1 per lento, 10 per veloce
        movlw     .3           ;
        xorwf     WCAMPH,0     ;
        btfsc     STATUS,2     ;
        goto      PULSA31      ; Se 1 vado a PULSA31
        movf      BAR03,0      ; Se 0 incremento
        addwf     WCAMPL,1     ; Incremento Watt campione di 1 o 10
        btfss     STATUS,0     ;
        goto      PULSA91      ; No arrivato al massimo
        incf      WCAMPH,1     ; Si arrivato al massimo
        goto      PULSA91      ;
PULSA31 movf      BAR03,0      ;
        addwf     WCAMPL,1     ; Incremento Watt camp di 1 o di 10
        movlw     .233         ;
        subwf     WCAMPL,0     ; Verifico se raggiunto il massimo
        btfss     STATUS,0     ;
        goto      PULSA91      ; no raggiunto
        clrf      WCAMPH       ; si raggiunto
        movlw     .50          ;
        movwf     WCAMPL       ;
        goto      PULSA91      ;
PULSA10 call      RITAST       ;
        btfss     P1           ; Verifica pulsante calibrazione WATT
        goto      PULSA13      ;
        call      MIDIR        ;
        goto      PULSA90      ; No riciclo per temporizzazione
PULSA13 btfss     P1           ; Si premuto aspetto il rilascio
        goto      PULSA13      ;
        clrf      BAR03        ;
        movlw     .79          ;
        xorwf     BAR06,0      ;
        btfss     STATUS,2     ;
        goto      LETTU        ;
;--------------------------------------------------------------------*
;   53  VIDEATA DI CONFERMA MEMORIZZAZIONE CALIBRAZIONE              *
;--------------------------------------------------------------------*
        movlw     .255         ;Calcolo fondo scala
        movwf     VDIRE        ;
        call      CALWAT       ;
CONFE   movlw     .200         ; Velocita' lampeggio
        movwf     BAR02        ;
        bcf       RS           ; Reg. Select a 0 per istruzioni
        call      RI005M       ;
        movlw     .1           ; Cursore in R2 C01
        call      WRITE        ;
        bsf       RS           ; Reg. Select a 1 per dati
        call      RI005M       ;
        movlw     'F'          ; R 1  C 01   =  F
        call      WRITE        ;
        movlw     's'          ; R 1  C 02   =  s
        call      WRITE        ;
        movlw     'c'          ; R 1  C 03   =  c
        call      WRITE        ;
        movlw     'a'          ; R 1  C 04   =  a
        call      WRITE        ;
        movlw     'l'          ; R 1  C 05   =  l
        call      WRITE        ;
        movlw     'a'          ; R 1  C 06   =  a
        call      WRITE        ;
        movlw     ' '          ; R 1  C 07   =  spazio
        call      WRITE        ;
        movlw     'm'          ; R 1  C 08   =  m
        call      WRITE        ;
        movlw     'a'          ; R 1  C 09   =  a
        call      WRITE        ;
        movlw     'x'          ; R 1  C 10   =  x
        call      WRITE        ;
        movlw     ' '          ; R 1  C 11   =  spazio
        call      WRITE        ;
        movf      PCEN,0       ; R 1  C 12   =  centinaia di watt
        call      WRITE        ;
        movf      PDEC,0       ; R 1  C 13   =  decine    di watt
        call      WRITE        ;
        movf      PUNI,0       ; R 1  C 14   =  unita'    di watt
        call      WRITE        ;
        movlw     '.'          ; R 1  C 15   =  .
        call      WRITE        ;
        movf      PVIR,0       ; R 1  C 16   =  decimali  di watt
        call      WRITE        ;
        bcf       RS           ; Reg. Select a 0 per istruzioni
        call      RI005M       ;
        movlw     .192         ; Cursore in R2 C01
        call      WRITE        ;
        bsf       RS           ; Reg. Select a 1 per dati
        call      RI005M       ;
        movlw     'm'          ; R 2  C 01   =  m
        call      WRITE        ;
        movlw     'e'          ; R 2  C 02   =  e
        call      WRITE        ;
        movlw     'm'          ; R 2  C 03   =  m
        call      WRITE        ;
        movlw     'o'          ; R 2  C 04   =  o
        call      WRITE        ;
        movlw     'r'          ; R 2  C 05   =  r
        call      WRITE        ;
        movlw     'i'          ; R 2  C 06   =  i
        call      WRITE        ;
        movlw     'z'          ; R 2  C 07   =  z
        call      WRITE        ;
        movlw     'z'          ; R 2  C 08   =  z
        call      WRITE        ;
        movlw     'o'          ; R 2  C 09   =  o
        call      WRITE        ;
        movlw     '?'          ; R 2  C 10   =  ?
        call      WRITE        ;
        movlw     ' '          ; R 2  C 11   =  spazio
        call      WRITE        ;
        movlw     'S'          ; R 2  C 12   =  spazio alternato
        btfsc     BAR03,1      ;
        movlw     ' '          ; R 2  C 12   =  S      alternato
        call      WRITE        ;
        movlw     'I'          ; R 2  C 13   =  spazio alternato
        btfsc     BAR03,1      ;
        movlw     ' '          ; R 2  C 13   =  I      alternato
        call      WRITE        ;
        movlw     ' '          ; R 2  C 14   =  spazio fisso
        call      WRITE        ;
        movlw     'N'          ; R 2  C 15   =  N      alternato
        btfsc     BAR03,0      ;
        movlw     ' '          ; R 2  C 15   =  spazio alternato
        call      WRITE        ;
        movlw     'O'          ; R 2  C 16   =  O      alternato
        btfsc     BAR03,0      ;
        movlw     ' '          ; R 2  C 16   =  spazio alternato
        call      WRITE        ;
PULCO90 decfsz    BAR02,1      ; Ciclo attesa e lampeggio
        goto      PULCO20      ; Lettura tasti per pressione
        btfss     BAR03,2      ; bit SI/NO 
        goto      NONO         ; bit a 0 vado al NO
        bcf       BAR03,0      ; bit a 1 setto fisso NO
        movlw     .2           ; Alterno il SI 
        xorwf     BAR03,1      ;
        goto      CONFE        ; Scrittura di conferma LCD >>>>>>>>>>>>>>
NONO    bcf       BAR03,1      ; Setto fisso SI 
        movlw     .1           ; Alterno il NO
        xorwf     BAR03,1      ;
        goto      CONFE        ; Scrittura conferma su LCD >>>>>>>>>>>>>>
PULCO20 call      RITAST       ; Pulsante P2 DOWN alterna SI NO
        btfsc     P2           ; Test pressione pulsante P2 DOWN
        goto      PULCO30      ; No premuto
PULCO21 btfss     P2           ; Si premuto
        goto      PULCO21      ; Aspetto il rilascio
        movlw     .4           ; Alterno SI/NO
        xorwf     BAR03,1      ;
PULCO30 call      RITAST       ; Tasto P3 UP alterna SI NO
        btfsc     P3           ; Test pressione pulsante P3 UP
        goto      PULCO10      ; No premuto
PULCO31 btfss     P3           ; Si premuto
        goto      PULCO31      ; Aspetto il rilascio
        movlw     .4           ; Alterno SI/NO
        xorwf     BAR03,1      ;
PULCO10 call      RITAST       ; Tasto P1 SET esce su memorizza
        btfsc     P1           ; Test pressione pulsante P1 SET
        goto      PULCO90      ; No premuto
PULCO13 btfss     P1           ; Si premuto
        goto      PULCO13      ; Aspetto il rilascio
        btfsc     BAR03,2      ; Test SI/NO di memorizzazione
        call      MEMO         ;
        goto      LETTU        ; No memorizzare
;--------------------------------------------------------------------*
;--------------------------------------------------------------------*
;  100  SUB SCRITTURA SU EEPROM Vdir LETTA E Pw SETTATO              *
;--------------------------------------------------------------------*
;--------------------------------------------------------------------*
MEMO    call      BANK2        ;
        movlw     .85          ; SPIA memorizzazione iniziale
        movwf     EEDATA       ;
        movlw     .0           ;
        movwf     EEADR        ;
        call      BANK3        ;
        bcf       EECON1,7     ;
        bsf       EECON1,2     ;
        movlw     .85          ;
        movwf     EECON2       ;
        movlw     .170         ;
        movwf     EECON2       ;
        bsf       EECON1,1     ;
        bcf       EECON1,2     ;
        call      RI060M       ;
        call      BANK0        ;
        call      BANK0        ;
        movf      TCAMP,0      ; VDIRE
        call      BANK2        ;
        movwf     EEDATA       ;
        movlw     .1           ;
        movwf     EEADR        ;
        call      BANK3        ;
        bcf       EECON1,7     ;
        bsf       EECON1,2     ;
        movlw     .85          ;
        movwf     EECON2       ;
        movlw     .170         ;
        movwf     EECON2       ;
        bsf       EECON1,1     ;
        bcf       EECON1,2     ;
        call      RI060M       ;
        call      BANK0        ;
        movf      WCAMPH,0     ; WCAMPH
        call      BANK2        ;
        movwf     EEDATA       ;
        movlw     .2           ;
        movwf     EEADR        ;
        call      BANK3        ;
        bcf       EECON1,7     ;
        bsf       EECON1,2     ;
        movlw     .85          ;
        movwf     EECON2       ;
        movlw     .170         ;
        movwf     EECON2       ;
        bsf       EECON1,1     ;
        bcf       EECON1,2     ;
        call      RI060M       ;
        call      BANK0        ;
        movf      WCAMPL,0     ; WCAMPL
        call      BANK2        ;
        movwf     EEDATA       ;
        movlw     .3           ;
        movwf     EEADR        ;
        call      BANK3        ;
        bcf       EECON1,7     ;
        bsf       EECON1,2     ;
        movlw     .85          ;
        movwf     EECON2       ;
        movlw     .170         ;
        movwf     EECON2       ;
        bsf       EECON1,1     ;
        bcf       EECON1,2     ;
        call      RI060M       ;
        call      BANK0        ;
        return                 ; Fine sub memo calibrazione
;--------------------------------------------------------------------*
;  101  SUB SCRITTA DI LAVORO LCD                                    *
;--------------------------------------------------------------------*
VISOR   bcf       RS           ; Reg. Select a 0 per istruzioni
        call      RI005M       ;
        movlw     .2           ; Cursore in R1 C01 e CLR
        call      WRITE        ;
        bsf       RS           ; Reg. Select a 1 per dati
        call      RI005M       ;
        movlw     'S'          ; R 1  C 01   =  S
        call      WRITE        ;
        movlw     'W'          ; R 1  C 02   =  W
        call      WRITE        ;
        movlw     'R'          ; R 1  C 03   =  R
        call      WRITE        ;
        movlw     ' '          ; R 1  C 04   =  spazio
        call      WRITE        ;
        movf      RUNI,0       ; R 1  C 05   =  unit SWR    / H
        call      WRITE        ;
        movf      RPUN,0       ; R 1  C 06   =  punto        / I
        call      WRITE        ;
        movf      RVIR,0       ; R 1  C 07   =  decimali SWR / G
        call      WRITE        ;
        movlw     ' '          ; R 1  C 08   =  spazio
        call      WRITE        ;
        movf      FLOT1,0      ; R 1  C 09   =  P
        call      WRITE        ;
        movf      FLOT2,0      ; R 1  C 10   =  w
        call      WRITE        ;
        movf      FLOT3,0      ; R 1  C 11   =  spazio
        call      WRITE        ;
        movf      PCEN,0       ; R 1  C 12   =  spazio
        call      WRITE        ;
        movf      PDEC,0       ; R 1  C 13   =  decine WATT
        call      WRITE        ;
        movf      PUNI,0       ; R 1  C 14   =  unit  WATT
        call      WRITE        ;
        movlw     '.'          ; R 1  C 15   =  .
        call      WRITE        ;
        movf      PVIR,0       ; R 1  C 16   =  decimali WATT5
        call      WRITE        ;
INBAR   bcf       RS           ; Reg. Select a 0 per istruzioni
        call      RI005M       ;
        movlw     .192         ; Cursore in R2 C01 e CLR
        call      WRITE        ;
        bsf       RS           ; Reg. Select a 1 per dati
        call      RI005M       ;
        movlw     .0           ; R 2  C 01  
        call      WRITE        ;
        movf      BAR01,0      ; R 2  C 02
        call      WRITE        ;
        movf      BAR02,0      ; R 2  C 03
        call      WRITE        ;
        movf      BAR03,0      ; R 2  C 04
        call      WRITE        ;
        movf      BAR04,0      ; R 2  C 05
        call      WRITE        ;
        movf      BAR05,0      ; R 2  C 06
        call      WRITE        ;
        movf      BAR06,0      ; R 2  C 07
        call      WRITE        ;
        movf      BAR07,0      ; R 2  C 08
        call      WRITE        ;
        movf      BAR08,0      ; R 2  C 09
        call      WRITE        ;
        movf      BAR09,0      ; R 2  C 10
        call      WRITE        ;
        movf      BAR10,0      ; R 2  C 11
        call      WRITE        ;
        movf      BAR11,0      ; R 2  C 12
        call      WRITE        ;
        movf      BAR12,0      ; R 2  C 13
        call      WRITE        ;
        movf      BAR13,0      ; R 2  C 14
        call      WRITE        ;
        movf      BAR14,0      ; R 2  C 15
        call      WRITE        ;
        movf      BAR15,0      ; R 2  C 16
        call      WRITE        ;
        return                 ;
;--------------------------------------------------------------------*
;  102  SUB ACQUISIZIONE VALORE TENSIONE DIRETTA                     *
;--------------------------------------------------------------------*
MIDIR   bsf       ADCON0,2     ; Bit 2     = 1   Start conversione
ATTES2  btfsc     ADCON0,2     ; Attesa termine conversione
        goto      ATTES2       ;
        movf      ADRESH,0     ; Risultato conversione A/D
        sublw     .25          ;
        btfsc     STATUS,0     ;
        return                 ;
        movf      ADRESH,0     ; Risultato conversione A/D
        movwf     PROV1L       ; Tensione diretta canale 0
        call      COR00        ;
        movf      PROV1L,0     ;
        movwf     TCAMP        ; Tensione diretta corretta
        subwf     BAR04,0      ; Trovo picco
        btfsc     STATUS,0     ;
        return                 ;
        movf      TCAMP,0      ;
        movwf     BAR04        ;
        movlw     'O'          ;
        movwf     BAR06        ;
        movlw     'K'          ;
        movwf     BAR07        ;
        return                 ;
;--------------------------------------------------------------------*
;  103  SUB CALCOLO E DISPLAY VALORE POTENZA (Pf) PICCO PICCO        *
;--------------------------------------------------------------------*
                               ;
;  WATT: (Vdir x Vdir x 100 x Wcamp) / (Vcamp x Vcamp) / 100
                               ;
CALWAT  movlw     .0           ;
        movwf     AARGB0       ; Parte alta  moltiplicando  a 0
        movwf     AARGB1       ; Parte media moltiplicando  a 0
        movwf     BARGB0       ; Parte alta  moltiplicatore a 0
        movf      TCAMP,0      ; Tens. campione memorizzata----Vcamp
        movwf     AARGB2       ; Parte L moltiplicando           X
        movwf     BARGB1       ; Parte L moltiplicatore--------Vcamp
                               ;
        call      MOLTI        ; MOLTIPLICAZIONE
                               ;
        movf      AARGB3,0     ; Risultato parte alta  in
        movwf     REMB0        ; variabile provvisoria
        movf      AARGB4,0     ; Risultato parte bassa in
        movwf     REMB1        ; variabile provvisoria
                               ;
        movlw     .0           ;
        movwf     AARGB0       ; Parte alta  moltiplicando  a 0
        movwf     AARGB1       ; Parte media moltiplicando  a 0
        movwf     BARGB0       ; Parte alta  moltiplicatore a 0
        movf      VDIRE,0      ; Tensione diretta misurata -------Vdir
        movwf     AARGB2       ; Parte bassa moltiplicando       X 
        movwf     BARGB1       ; Parte bassa moltiplicatore-------Vdir
                               ;
        call      MOLTI        ; MOLTIPLICAZIONE
                               ;
        movf      AARGB3,0     ; Risultato parte alta  in 
        movwf     AARGB1       ; Parte media moltiplicando 
        movf      AARGB4,0     ; Risultato parte bassa in
        movwf     AARGB2       ; Parte bassa moltiplicando
        movlw     .0           ;                          
        movwf     BARGB0       ; Parte H moltiplicatore-----Vdir x Vdir
        movlw     .100         ; Tensione diretta misurata       X
        movwf     BARGB1       ; Parte L moltiplicatore---------100
                               ;
        call      MOLTI        ; MOLTIPLICAZIONE
                               ;
        movf      AARGB2,0     ; Risultato parte alta  in
        movwf     AARGB0       ; parte alta  moltiplicando
        movf      AARGB3,0     ; Risultato parte media in
        movwf     AARGB1       ; parte media moltiplicando
        movf      AARGB4,0     ; Risultato parte bassa in 
        movwf     AARGB2       ; parte bassa moltiplicando
        movf      WCAMPH,0     ; Wcampione parte alta in
        movwf     BARGB0       ; parte H moltiplicatore----VdirxVdirX100
        movf      WCAMPL,0     ; Wcampione parte bassa in         X
        movwf     BARGB1       ; parte L moltiplicatore-------Wcampione
                               ;
        call      MOLTI        ; MOLTIPLICAZIONE
                               ;
        movf      AARGB1,0     ; Risultato parte alta  in 
        movwf     AARGB0       ; parte alta dividendo
        movf      AARGB2,0     ; Risultato parte alta  in 
        movwf     AARGB1       ; parte alta dividendo
        movf      AARGB3,0     ; Risultato parte bassa in
        movwf     AARGB2       ; parte bassa dividendo
        movf      AARGB4,0     ; Risultato parte bassa in
        movwf     AARGB3       ; parte bassa dividendo
        movf      REMB0,0      ;
        movwf     BARGB0       ; Parte H dividendo------Vd x Vd x 100 x Wc
        movf      REMB1,0      ;                                 :
        movwf     BARGB1       ; Parte L dividendo------------Vr x Vr
                               ;
        call      DIVIS        ; DIVISIONE
                               ;
        movlw     .0           ;
        movwf     BARGB0       ; Parte H divisore--(VdxVdX100XWc) / (VrxVr)
        movlw     .100         ;                                 :
        movwf     BARGB1       ; Parte bassa divisore-----------100
                               ;
        call      DIVIS        ; DIVISIONE
                               ;
        movf      AARGB2,0     ; Parte alta  risultato divisione
        movwf     VHIG         ;
        movf      AARGB3,0     ; Parte bassa risultato divisione
        movwf     VLOW         ;
        call      COLLE        ;
        movf      V01000,0     ; Risultato scomposizione
        addlw     .48          ; Prefisso ASCII
        movwf     PCEN         ; Centinaia di WATT
        movf      V00100,0     ; Risultato scomposizione
        addlw     .48          ; Prefisso ASCII
        movwf     PDEC         ; Decine WATT
        movf      V00010,0     ; Risultato scomposizione
        addlw     .48          ; Prefisso ASCII
        movwf     PUNI         ; Unit  WATT
        movf      V00001,0     ; Risultato scomposizione
        addlw     .48          ; Prefisso ASCII
        movwf     PVIR         ; Decimali WATT
        return                 ;
;--------------------------------------------------------------------*
; 104   SUB RITARDI VARI CRISTALLO 4M                                *
;--------------------------------------------------------------------*
RI750M  movlw     .7           ; Ritardo di 1,3 S.  circa
        movwf     FR01         ;
        movlw     .100         ;
        movwf     FR02         ;
        movlw     .255         ;
        movwf     FR03         ;
        goto      CIRIT        ;
RI500M  movlw     .2           ; Ritardo di 500 mS.  circa
        movwf     FR01         ;
        movlw     .50          ;
        movwf     FR02         ;
        movlw     .255         ;
        movwf     FR03         ;
        goto      CIRIT        ;
RI060M  movlw     .1           ; Ritardo di 100 mS.  circa
        movwf     FR01         ;
        movlw     .20          ;
        movwf     FR02         ;
        movlw     .255         ;
        movwf     FR03         ;
        goto      CIRIT        ;
RITAST  movlw     .1           ; Ritardo di 100 mS.  circa
        movwf     FR01         ;
        movlw     .1           ;
        movwf     FR02         ;
        movlw     .200         ;
        movwf     FR03         ;
        goto      CIRIT        ;
RI005M  movlw     .1           ; Ritardo di   5 mS.  reali
        movwf     FR01         ;
        movlw     .7           ;
        movwf     FR02         ;
        movlw     .147         ;
        movwf     FR03         ;
        goto      CIRIT        ;
RI0002  movlw     .1           ; Ritardo di  20 uS.   reali
        movwf     FR03         ;
RIT000  movlw     .1           ; Meccanismo di ritardo 
        movwf     FR01         ;
        movlw     .1           ;
        movwf     FR02         ;
CIRIT   decfsz    FR03,1       ; Ciclo di ritardo
        goto      CIRIT        ;
        decfsz    FR02,1       ;
        goto      CIRIT        ;
        decfsz    FR01,1       ;
        goto      CIRIT        ;
        return                 ; Fine SUB ritardo
;--------------------------------------------------------------------*
;  105  SUB CORREZIONE VALORI LETTI                                  *
;--------------------------------------------------------------------*
COR00   movlw     .241         ;
        subwf     PROV1L,0     ;
        btfss     STATUS,0     ;
        goto      COR01        ; Da 4.722         corretto 5.000
        movlw     .255         ;
        movwf     PROV1L       ;
        return                 ; Fine correzione >>>>>>>>>>>>>>>>>>>>>>>>
COR01   movlw     .123         ;
        subwf     PROV1L,0     ;
        btfss     STATUS,0     ;
        goto      COR02        ;
        movlw     .14          ; Da 2.389 a 4.721 corretto   279
        goto      CORO7        ;
COR02   movlw     .42          ;
        subwf     PROV1L,0     ;
        btfss     STATUS,0     ;
        goto      COR03        ;
        movlw     .12          ; Da   797 a 2.388 corretto   239
        goto      CORO7        ;
COR03   movlw     .13          ;
        subwf     PROV1L,0     ;
        btfss     STATUS,0     ;
        goto      COR04        ;
        movlw     .10          ; Da   240 a   796 corretto   199
        goto      CORO7        ;
COR04   movlw     .6           ;
        subwf     PROV1L,0     ;
        btfss     STATUS,0     ;
        goto      COR05        ;
        movlw     .8           ; Da    97 a   239 corretto   159
        goto      CORO7        ;
COR05   movlw     .3           ;
        subwf     PROV1L,0     ;
        btfss     STATUS,0     ;
        goto      COR06        ;
        movlw     .6           ; Da    30 a    96 corretto   119
        goto      CORO7        ;
COR06   movlw     .0           ; Da     0 a    30 corretto     0
CORO7   addwf     PROV1L,1     ;
        return                 ; Fine correzione >>>>>>>>>>>>>>>>>>>>>>>>
;--------------------------------------------------------------------*
;  106  SUB CLOCK LCD                                                *
;--------------------------------------------------------------------*
CLOCK2  bsf       CLK          ; Enebol scende a 0 per dato
        call      RI0002       ; Ritardo
        bcf       CLK          ; Enebol sale a 1 in attesa
        call      RI0002       ; Ritardo
        return                 ;
;--------------------------------------------------------------------*
;  107  SUB SCRITTURA DI UN CARATRTERE SU LCD                        *
;--------------------------------------------------------------------*
WRITE   movwf     FR04         ;
        swapf     FR04,0       ;
        movwf     PORTC        ;
        bsf       CLK          ;
        call      RI0002       ;
        bcf       CLK          ;
        call      RI0002       ;
        movf      FR04,0       ;
        movwf     PORTC        ;
        bsf       CLK          ;
        call      RI0002       ;
        bcf       CLK          ;
        call      RI0002       ;
        return                 ;
;--------------------------------------------------------------------*
;  108  SUB SELEZIONE BANK                                           *
;--------------------------------------------------------------------*
BANK0   bcf       STATUS,6     ;
        bcf       STATUS,5     ;
        return                 ;
BANK1   bcf       STATUS,6     ;
        bsf       STATUS,5     ;
        return                 ;
BANK2   bsf       STATUS,6     ;
        bcf       STATUS,5     ;
        return                 ;
BANK3   bsf       STATUS,6     ;
        bsf       STATUS,5     ;
        return                 ;
;--------------------------------------------------------------------*
;  109  SUB SCOMPOSIZIONE NUMERI                                     *
;--------------------------------------------------------------------*
COLLE   clrf      V00001       ;
        clrf      V00010       ;
        clrf      V00100       ;
        clrf      V01000       ;
        clrf      V10000       ;
        movf      VHIG,0       ;
        xorlw     .0           ;
        btfsc     STATUS,2     ;
        goto      DIV03        ;
        call      DIV02        ;
DIV00   decfsz    VHIG,1       ;
        goto      DIV01        ;
        goto      DIV03        ;
DIV01   call      DIV02        ;
        goto      DIV00        ;
DIV02   call      I00100       ; 2 centinaia
        call      I00100       ;
        call      I00010       ; 5 decine
        call      I00010       ;
        call      I00010       ;
        call      I00010       ;
        call      I00010       ;
        call      I00001       ; 6 unita'
        call      I00001       ;
        call      I00001       ;
        call      I00001       ;
        call      I00001       ;
        call      I00001       ;
        return                 ;
DIV03   movlw    .0           ;
        xorwf     VLOW,0       ;
        btfsc     STATUS,2     ;
        return                 ;
        call      I00001       ;
DIV04   decfsz    VLOW,1       ;
        goto      DIV05        ;
        return                 ;
DIV05   call      I00001       ;
        goto      DIV04        ;
I00001  incf      V00001,1     ; Incremento delle unita
        movf      V00001,0     ;
        xorlw     .10          ; A 10 unit azzero e inc. decine
        btfss     STATUS,2     ;
        return                 ; Se meno di 10 torno  >>>>>>>>>>>>>>>>>>>
        clrf      V00001       ;
I00010  incf      V00010,1     ; Incremento delle decine 
        movf      V00010,0     ;
        xorlw     .10          ; A 10 decine azzero e inc. centinaia
        btfss     STATUS,2     ;
        return                 ; Se meno di 10 torno  >>>>>>>>>>>>>>>>>>>
        clrf      V00010       ; Incremento delle centinaia
I00100  incf      V00100,1     ;
        movf      V00100,0     ;
        xorlw     .10          ; A 10 centinaia azz. e inc migliaia
        btfss     STATUS,2     ;
        return                 ; Se meno di 10 torno  >>>>>>>>>>>>>>>>>>>
        clrf      V00100       ;
I01000  incf      V01000,1     ;
        movf      V01000,0     ;
        xorlw     .10          ; A 10 migliaia azz. e inc diecimila
        btfss     STATUS,2     ;
        return                 ; Se meno di 10 torno  >>>>>>>>>>>>>>>>>>>
        clrf      V01000       ;
I10000  incf      V10000,1     ;
        return                 ; ritorno >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;--------------------------------------------------------------------*
;  110  SUB ADDIZIONE, SOTTRAZIONE, MOLTIPLICAZIONE e DIVISIONE      *
;--------------------------------------------------------------------*
; Add: ACCb(16 bits) + ACCa(16 bits) -> ACCb(16 bits)
; Sub: ACCb(16 bits) - ACCa(16 bits) -> ACCb(16 bits)
D_sub   call      neg_A        ;
D_add   movf      ACCaLO,W     ;
     	addwf     ACCbLO,1     ;
    	btfsc     STATUS,0     ; Un gnaro de vespe
    	incf      ACCbHI,1     ; meio non tocare
    	movf      ACCaHI,0     ;
    	addwf     ACCbHI,1     ;
	    retlw     0            ;
neg_A   comf      ACCaLO,1     ;
    	incf      ACCaLO,1     ;
    	btfsc     STATUS,2     ;
    	decf      ACCaHI,1     ;
    	comf      ACCaHI,1     ;
    	retlw     0            ;
; Moltip: 24x16 Bit Unsigned Fixed Point Multiply 24x16 -> 40
MOLTI   CLRF      AARGB3       ;
        CLRF      AARGB4       ;
        MOVF      AARGB0,W     ;
        MOVWF     TEMPB0       ;
        MOVF      AARGB1,W     ;
        MOVWF     TEMPB1       ;
        MOVF      AARGB2,W     ;
        MOVWF     TEMPB2       ;
        MOVLW     0x08         ;
        MOVWF     COUNT1       ;
LOOPUM2416A                    ;
        RRF       BARGB1, 1    ;
        BTFSC     STATUS,0     ;
        GOTO      ALUM2416NAP  ;
        DECFSZ    COUNT1, 1    ;
        GOTO      LOOPUM2416A  ;
        MOVWF     COUNT1       ;
LOOPUM2416B                    ;
        RRF       BARGB0, 1    ;
        BTFSC     STATUS,0     ;
        GOTO      BLUM2416NAP  ;
        DECFSZ    COUNT1, 1    ;
        GOTO      LOOPUM2416B  ;
        CLRF      AARGB0       ;
        CLRF      AARGB1       ;
        CLRF      AARGB2       ;
        RETLW     0x00         ;
BLUM2416NAP                    ;
        BCF       STATUS,0     ;
        GOTO      BLUM2416NA   ;
ALUM2416NAP                    ;
        BCF       STATUS,0     ;
        GOTO      ALUM2416NA   ;
ALOOPUM2416                    ;
        RRF       BARGB1, 1    ;
        BTFSS     STATUS,0     ;
        GOTO      ALUM2416NA   ;
        MOVF      TEMPB2,0     ;
        ADDWF     AARGB2, 1    ;
        MOVF      TEMPB1,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    TEMPB1,0     ;
        ADDWF     AARGB1, 1    ;
        MOVF      TEMPB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    TEMPB0,0     ;
        ADDWF     AARGB0, 1    ;
ALUM2416NA                     ;
        RRF       AARGB0, 1    ;
        RRF       AARGB1, 1    ;
        RRF       AARGB2, 1    ;
        RRF       AARGB3, 1    ;
        DECFSZ    COUNT1, 1    ;
        GOTO      ALOOPUM2416  ;
        MOVLW     0x08         ;
        MOVWF     COUNT1       ;
BLOOPUM2416                    ;
        RRF       BARGB0, 1    ;
        BTFSS     STATUS,0     ;
        GOTO      BLUM2416NA   ;
        MOVF      TEMPB2,0     ;
        ADDWF     AARGB2, 1    ;
        MOVF      TEMPB1,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    TEMPB1,0     ;
        ADDWF     AARGB1, 1    ;
        MOVF      TEMPB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    TEMPB0,0     ;
        ADDWF     AARGB0, 1    ;
BLUM2416NA                     ;
        RRF       AARGB0, 1    ;
        RRF       AARGB1, 1    ;
        RRF       AARGB2, 1    ;
        RRF       AARGB3, 1    ;
        RRF       AARGB4, 1    ;
        DECFSZ    COUNT1, 1    ;
        GOTO      BLOOPUM2416  ;
        return                 ;
; Divis: 32/16 Bit Unsigned Fixed Point Divide 32/16 -> 32.16
DIVIS   CLRF      REMB0        ;
        CLRF      REMB1        ;
UDIV3216L                      ; macro
        CLRF      TEMP         ;
        RLF       AARGB0,0     ;
        RLF       REMB1,1      ;
        MOVF      BARGB1,0     ;
        SUBWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSS     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        SUBWF     REMB0,1      ;
        CLRW                   ;
        BTFSS     STATUS,0     ;
        MOVLW     1            ;
        SUBWF     TEMP,1       ;
        RLF       AARGB0,1     ;
        MOVLW     7            ;
        MOVWF     COUNT1       ;
LOOPU3216A                     ;
        RLF       AARGB0,0     ;
        RLF       REMB1,1      ;
        RLF       REMB0,1      ;
        RLF       TEMP,1       ;
        MOVF      BARGB1,0     ;
        BTFSS     AARGB0,0     ;
        GOTO      UADD26LA     ;
        SUBWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSS     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        SUBWF     REMB0,1      ;
        CLRW                   ;
        BTFSS     STATUS,0     ;
        MOVLW     1            ;
        SUBWF     TEMP,1       ;
        GOTO      UOK26LA      ;
UADD26LA                       ;
        ADDWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        ADDWF     REMB0,1      ;
        CLRW                   ;
        BTFSC     STATUS,0     ;
        MOVLW     1            ;
        ADDWF     TEMP,1       ;
UOK26LA RLF       AARGB0,1     ;
        DECFSZ    COUNT1,1     ;
        GOTO      LOOPU3216A   ;
        RLF       AARGB1,0     ;
        RLF       REMB1,1      ;
        RLF       REMB0,1      ;
        RLF       TEMP,1       ;
        MOVF      BARGB1,0     ;
        BTFSS     AARGB0,0     ;
        GOTO      UADD26L8     ;
        SUBWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSS     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        SUBWF     REMB0,1      ;
        CLRW                   ;
        BTFSS     STATUS,0     ;
        MOVLW     1            ;
        SUBWF     TEMP,1       ;
        GOTO      UOK26L8      ;
UADD26L8                       ;
        ADDWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        ADDWF     REMB0,1      ;
        CLRW                   ;
        BTFSC     STATUS,0     ;
        MOVLW     1            ;
        ADDWF     TEMP,1       ;
UOK26L8 RLF       AARGB1,1     ;
        MOVLW     7            ;
        MOVWF     COUNT1       ;
LOOPU3216B                     ;
        RLF       AARGB1,0     ;
        RLF       REMB1,1      ;
        RLF       REMB0,1      ;
        RLF       TEMP,1       ;
        MOVF      BARGB1,0     ;
        BTFSS     AARGB1,0     ;
        GOTO      UADD26LB     ;
        SUBWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSS     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        SUBWF     REMB0,1      ;
        CLRW                   ;
        BTFSS     STATUS,0     ;
        MOVLW     1            ;
        SUBWF     TEMP,1       ;
        GOTO      UOK26LB      ;
UADD26LB                       ;
        ADDWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        ADDWF     REMB0,1      ;
        CLRW                   ;
        BTFSC     STATUS,0     ;
        MOVLW     1            ;
        ADDWF     TEMP,1       ;
UOK26LB                        ;
        RLF       AARGB1,1     ;
        DECFSZ    COUNT1,1     ;
        GOTO      LOOPU3216B   ;
        RLF       AARGB2,0     ;
        RLF       REMB1,1      ;
        RLF       REMB0,1      ;
        RLF       TEMP,1       ;
        MOVF      BARGB1,0     ;
        BTFSS     AARGB1,0     ;
        GOTO      UADD26L16    ;
        SUBWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSS     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        SUBWF     REMB0,1      ;
        CLRW                   ;
        BTFSS     STATUS,0     ;
        MOVLW     1            ;
        SUBWF     TEMP,1       ;
        GOTO      UOK26L16     ;
UADD26L16                      ;
        ADDWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        ADDWF     REMB0,1      ;
        CLRW                   ;
        BTFSC     STATUS,0     ;
        MOVLW     1            ;
        ADDWF     TEMP,1       ;
UOK26L16                       ;
        RLF       AARGB2,1     ;
        MOVLW     7            ;
        MOVWF     COUNT1       ;
LOOPU3216C                     ;
        RLF       AARGB2,0     ;
        RLF       REMB1,1      ;
        RLF       REMB0,1      ;
        RLF       TEMP,1       ;
        MOVF      BARGB1,0     ;
        BTFSS     AARGB2,0     ;
        GOTO      UADD26LC     ;
        SUBWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSS     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        SUBWF     REMB0,1      ;
        CLRW                   ;
        BTFSS     STATUS,0     ;
        MOVLW     1            ;
        SUBWF     TEMP,1       ;
        GOTO      UOK26LC      ;
UADD26LC                       ;
        ADDWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        ADDWF     REMB0,1      ;
        CLRW                   ;
        BTFSC     STATUS,0     ;
        MOVLW     1            ;
        ADDWF     TEMP,1       ;
UOK26LC                        ;
        RLF       AARGB2,1     ;
        DECFSZ    COUNT1,1     ;
        GOTO      LOOPU3216C   ;
        RLF       AARGB3,0     ;
        RLF       REMB1,1      ;
        RLF       REMB0,1      ;
        RLF       TEMP,1       ;
        MOVF      BARGB1,0     ;
        BTFSS     AARGB2,0     ;
        GOTO      UADD26L24    ;
        SUBWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSS     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        SUBWF     REMB0,1      ;
        CLRW                   ;
        BTFSS     STATUS,0     ;
        MOVLW     1            ;
        SUBWF     TEMP,1       ;
        GOTO      UOK26L24     ;
UADD26L24                      ;
        ADDWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        ADDWF     REMB0,1      ;
        CLRW                   ;
        BTFSC     STATUS,0     ;
        MOVLW     1            ;
        ADDWF     TEMP,1       ;
UOK26L24                       ;
        RLF       AARGB3,1     ;
        MOVLW     7            ;
        MOVWF     COUNT1       ;
LOOPU3216D                     ;
        RLF       AARGB3,0     ;
        RLF       REMB1,1      ;
        RLF       REMB0,1      ;
        RLF       TEMP,1       ;
        MOVF      BARGB1,0     ;
        BTFSS     AARGB3,0     ;
        GOTO      UADD26LD     ;
        SUBWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSS     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        SUBWF     REMB0,1      ;
        CLRW                   ;
        BTFSS     STATUS,0     ;
        MOVLW     1            ;
        SUBWF     TEMP,1       ;
        GOTO      UOK26LD      ;
UADD26LD                       ;
        ADDWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        ADDWF     REMB0,1      ;
        CLRW                   ;
        BTFSC     STATUS,0     ;
        MOVLW     1            ;
        ADDWF     TEMP,1       ;
UOK26LD RLF       AARGB3,1     ;
        DECFSZ    COUNT1,1     ;
        GOTO      LOOPU3216D   ;
        BTFSC     AARGB3,0     ;
        GOTO      UOK26L       ;
        MOVF      BARGB1,0     ;
        ADDWF     REMB1,1      ;
        MOVF      BARGB0,0     ;
        BTFSC     STATUS,0     ;
        INCFSZ    BARGB0,0     ;
        ADDWF     REMB0,1      ;
UOK26L  return                 ;
        end                    ;
